<template>
  <v-layout align-center justify-center row wrap color="#f6f6f6">
    <v-dialog v-model="dialogLoader" persistent width="400">
      <v-card color="gray" dark>
        <v-card-text>
          Loading...
          <v-progress-linear
            indeterminate
            color="white"
            class="mb-0"
          ></v-progress-linear>
        </v-card-text>
      </v-card>
    </v-dialog>
    <v-flex xs12 pa-1>
      <v-layout>
        <v-flex xs12>
          <div class="font-size-24-bold">Upload Customer</div>
        </v-flex>
      </v-layout>
      <div>
        <br />
        <v-form ref="formExcel" lazy-validation>
          <!-- Sheet Name -->
          <p
            style="border: 2px dashed grey; text-align:center; background-color:#F3F3F3;"
          >
            <v-icon color="#2a95bf" large style="padding: 24px;"
              >mdi-cloud-upload</v-icon
            ><br />
            <b>Upload Excel File</b>
            <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 0 0;"
            >
              <v-flex xs4 v-if="!mobileView"
                ><a style="color:#2a95bf;" href="/example_company.xlsx"
                  >Download Example File</a
                ></v-flex
              >
              <v-flex xs6 v-if="mobileView"
                ><a style="color:#2a95bf;" href="/example_company.xlsx"
                  >Download Example File</a
                ></v-flex
              >
            </v-layout>
            <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 0 0;"
            >
              <v-flex xs1 v-if="!mobileView"
                ><p class="font-size-16">
                  Sheet Name<span style="color: red;">&nbsp;*</span>
                </p></v-flex
              >
              <v-flex xs4 v-if="mobileView"
                ><p class="font-size-14">
                  Sheet Name<span style="color: red;">&nbsp;*</span>
                </p></v-flex
              >
              <v-flex xs4 pt-2 px-2 v-if="!mobileView">
                <!-- <v-text-field type="text" name="invoiceno" id="invoiceno" v-model="sheetName" color="black" solo single-line height="40"></v-text-field> -->
                <v-text-field
                  class="uploadField"
                  required
                  ref="sheetName"
                  label="Enter sheet name in excel"
                  v-model="sheetName"
                  :rules="[() => !!sheetName || 'This field is required']"
                  color="black"
                  solo
                  single-line
                  height="40"
                  counter="30"
                  hint="Company"
                >
                </v-text-field>
              </v-flex>
              <v-flex xs6 pt-2 px-2 v-if="mobileView">
                <v-text-field
                  class="uploadField"
                  required
                  ref="sheetName"
                  label="Sheet name.."
                  v-model="sheetName"
                  :rules="[() => !!sheetName || 'This field is required']"
                  color="black"
                  solo
                  single-line
                  height="40"
                  counter="30"
                  hint="example.xlsx"
                >
                </v-text-field>
              </v-flex>
            </v-layout>

            <!-- Select File -->
            <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 0 0;"
            >
              <v-flex xs2 v-if="!mobileView"
                ><p class="font-size-16">
                  Select File<span style="color: red;">&nbsp;*</span>
                </p></v-flex
              >
              <v-flex xs4 v-if="mobileView"
                ><p class="font-size-14">
                  Select File<span style="color: red;">&nbsp;*</span>
                </p></v-flex
              >
              <v-flex
                xs4
                style="text-align:left; padding: 0px 0px 0px 0px;"
                v-if="!mobileView"
              >
                <v-chip class="black--text" v-show="fileName">
                  {{ fileName
                  }}<v-icon class="ml-3 cursor-pointer" @click="clearFile()"
                    >clear</v-icon
                  >
                </v-chip>
              </v-flex>
              <v-flex
                xs6
                style="text-align:left; padding: 0px 0px 0px 0px;"
                v-if="mobileView"
              >
                <v-chip class="black--text" v-show="fileName">
                  {{ fileName
                  }}<v-icon class="ml-3 cursor-pointer" @click="clearFile()"
                    >clear</v-icon
                  >
                </v-chip>
              </v-flex>
            </v-layout>

            <!-- Browse -->
            <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 0 0;"
            >
              <input
                type="file"
                ref="fileExcel"
                style="display: none;"
                @change="setFileName()"
                accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
              />
              <v-btn
                round
                outline
                depressed
                @click="$refs.fileExcel.click()"
                style="color:#2a95bf;"
                >Choose File&nbsp;&nbsp;&nbsp;
                <v-icon>mdi-file-find</v-icon>
              </v-btn>
            </v-layout>

            <!-- Submit -->
            <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 24px 0;"
            >
              <v-btn
                v-if="!statusUpload"
                round
                color="#2a95bf"
                style="color:white;"
                @click="uploadFile()"
                >&ensp;&emsp;&emsp;Submit&emsp;&emsp;&ensp;</v-btn
              >
            </v-layout>
          </p>
        </v-form>
        <!-- statusOldUpload: {{statusOldUpload}}<br>
      statusUpload: {{statusUpload}}<br>
      uploadData: {{uploadData}} -->
        <div v-if="showReview" class="pt-4">
          <div class="font-size-24-bold">Review</div>
          <br />
          <v-data-table
            :headers="headers"
            :items="uploadData"
            class="elevation-1"
          >
            <template v-slot:items="props">
              <td class="text-xs-left">{{ props.item.company_taxid }}</td>
              <td class="text-xs-left">{{ props.item.company_id }}</td>
              <td class="text-xs-left">{{ props.item.company_nameth }}</td>
              <td class="text-xs-left">{{ props.item.company_nameen }}</td>
              <td class="text-xs-left">{{ props.item.company_email }}</td>
              <td
                v-if="
                  props.item.action_description &&
                    props.item.action_description !== 'skip' &&
                    props.item.action_description !== 'overwrite'
                "
                class="text-xs-center"
                style="color:#F44336;"
              >
                <strong
                  v-if="
                    props.item.action_description === 'duplicate Company Tax ID'
                  "
                  >Duplicate Customer Tax ID</strong
                >
                <strong v-else>{{ props.item.action_description }}</strong>
                <br />
                <v-btn
                  v-if="
                    props.item.action_description ===
                      'duplicate Company Tax ID in excel file' ||
                      props.item.action_description ===
                        'duplicate Company Tax ID'
                  "
                  round
                  outline
                  depressed
                  @click="skip(props.item.no)"
                  style="color:#9E9E9E;"
                  >Skip</v-btn
                >
                <v-btn
                  v-if="
                    props.item.action_description === 'duplicate Company Tax ID'
                  "
                  round
                  @click="overwrite(props.item.no)"
                  color="#9E9E9E"
                  style="color:white;"
                  >Replace</v-btn
                >
              </td>
              <td v-else class="text-xs-center">
                <strong>{{ props.item.action_description }}</strong>
              </td>
            </template>
          </v-data-table>
          <v-layout
            align-center
            justify-start
            class="justify-center"
            style="margin: 20px 0 24px 0;"
          >
            <v-btn outline depressed @click="clearFile()" style="color:#9E9E9E;"
              >Cancel</v-btn
            >
            <v-btn
              v-if="
                statusUpload === 'confirm' || statusUpload === 'wait confirm'
              "
              color="#2a95bf"
              style="color:white;"
              @click="confirm()"
              >Confirm</v-btn
            >
          </v-layout>
        </div>
      </div>
    </v-flex>
  </v-layout>
</template>

<script>
import { sync } from "vuex-pathify";
import moment from "moment";
import Swal from "sweetalert2";
moment.locale("en");
export default {
  data() {
    return {
      mobileView: false,
      sheetName: "",
      fileName: "",
      isFile: false,
      userName: this.$cookies.get("username"),
      dialogLoader: false,
      showReview: false,
      headers: [
        {
          text: "Customer Tax ID",
          align: "left",
          sortable: false,
          value: "company_taxid"
        },
        {
          text: "Customer ID",
          align: "left",
          sortable: false,
          value: "company_id"
        },
        {
          text: "Customer Name TH",
          align: "left",
          sortable: false,
          value: "company_nameth"
        },
        {
          text: "Customer Name EN",
          align: "left",
          sortable: false,
          value: "company_nameen"
        },
        {
          text: "Email",
          align: "left",
          sortable: false,
          value: "company_email"
        },
        {
          text: "Action Description",
          align: "center",
          sortable: false,
          value: "action_description"
        }
      ],
      uploadData: [],
      statusUpload: "",
      statusOldUpload: "",
      setInterval: ""
    };
  },
  methods: {
    skip(index) {
      this.uploadData[index - 1].action_description = "skip";
    },
    overwrite(index) {
      this.uploadData[index - 1].action_description = "overwrite";
    },
    setFileName() {
      this.fileName = this.$refs.fileExcel.files[0].name;
      this.isFile = true;
    },
    clearFile() {
      // this.isFile = false
      // this.fileName = ''
      // this.$refs.formExcel.reset()
      location.reload();
    },
    checkUploadFile() {
      // console.log('checkUploadFile');
      let validate = true;
      for (let i = 0; i < this.uploadData.length; i++) {
        if (
          this.uploadData[i].action_description &&
          this.uploadData[i].action_description !== "skip" &&
          this.uploadData[i].action_description !== "overwrite"
        ) {
          validate = false;
          break;
        }
      }
      if (validate === true) {
        this.statusUpload = "confirm";
        clearInterval(this.setInterval);
      }
    },
    async confirm() {
      this.dialogLoader = true;
      if (this.statusOldUpload === "duplicate Company Tax ID in excel file") {
        this.statusOldUpload = "no duplicate Company Tax ID in excel file";
      }
      if (
        this.statusOldUpload === "duplicate Company Tax ID" ||
        this.statusOldUpload === "wait confirm"
      ) {
        this.statusOldUpload = "confirm";
      }
      var { data: company_data } = await this.axios.post(
        process.env.VUE_APP_APIHOST + "/check_file_company",
        {
          username: this.userName,
          data: this.uploadData,
          status: this.statusOldUpload
        },
        { headers: { Authorization: this.$cookies.get("token") } }
      );
      // console.log('check_file_company: ', company_data)
      this.dialogLoader = false;
      this.statusUpload = company_data.status;
      this.statusOldUpload = company_data.status;
      if (company_data.status === "success") {
        this.showReview = false;
        Swal.fire({
          title: "Upload Successful",
          text: "",
          icon: "success"
        }).then(function() {
          location.reload();
        });
      } else {
        this.uploadData = company_data.data;
        this.setInterval = setInterval(() => this.checkUploadFile(), 5000);
      }
    },
    async uploadFile() {
      if (this.$refs.formExcel.validate()) {
        if (this.isFile && this.sheetName) {
          this.dialogLoader = true;
          var data = new FormData();
          // data.append('username', this.userName)
          data.append("sheetname", this.sheetName);
          data.append("file", this.$refs.fileExcel.files[0]);
          var { data: upload_data } = await this.axios.post(
            `${process.env.VUE_APP_APIHOST}/upload_file_company`,
            data,
            {
              headers: { Authorization: this.$cookies.get("token") }
            }
          );
          // console.log('upload_file_company: ', upload_data)
          this.dialogLoader = false;
          this.statusUpload = upload_data.status;
          this.statusOldUpload = upload_data.status;

          if (upload_data.status === "wait confirm") {
            this.showReview = true;
            this.uploadData = upload_data.data;
            clearInterval(this.setInterval);
          } else if (
            upload_data.status === "Incomplete format" ||
            upload_data.status === "Sheet name not found"
          ) {
            this.$swal("Upload Failed", upload_data.status, "error");
          } else {
            this.showReview = true;
            this.uploadData = upload_data.data;
            this.setInterval = setInterval(() => this.checkUploadFile(), 5000);
          }
        }
      }
    },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    }
  },
  created() {
    this.handleView();
    window.addEventListener("resize", this.handleView);
  }
};
</script>

<style>
table {
  width: 10%;
}
.mytable table th {
  border-bottom: none;
  font-weight: bolder;
}
.v-text-field input {
  font-size: 0.9em;
}
.v-input__slot {
  min-height: 26px !important;
}
.v-input__icon--prepend .v-icon {
  color: black;
}
</style>
